package org.ugasp.test.client;


import org.ugasp.android.client.RMAIClientManager;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;


public class Main extends Activity {

	private Button		buttonConnect;
	private	Button 		buttonQuit;
	
	private EditText 	editText;
	private Button		buttonSend;

	MyUGASPClient 	client;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		// instantiate buttons
		initButtonConnect();
		initButtonQuit();

		// instantiate editText and matching button
		editText  = (EditText)findViewById(R.id.editText);
		initButtonSend();
	}

	private void initButtonConnect() {
		buttonConnect = (Button)findViewById(R.id.buttonConnect);
		buttonConnect.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				client = new MyUGASPClient();
				Thread t = new Thread(client);
				t.start();
			}
		});
	}


	private void initButtonQuit() {
		buttonQuit = (Button)findViewById(R.id.buttonQuit);
		buttonQuit.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				if(client != null && client.getID().isActorSessionIDValid()){
					short actorSessionId = client.getID().getActorSessionID();
					client.getLobbyMgr().quitApplicationInstance(actorSessionId);
				}
			}
		});
	}

	private void initButtonSend() {
		buttonSend = (Button)findViewById(R.id.buttonSend);
		buttonSend.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				if(client != null){
					String message = editText.getText().toString();
					client.getDataTransmissionMgr().getRMAIMgr().remoteMethodAsynchronousInvocation(
							RMAIClientManager.ActorSessionID.uGASP_GAME_LOGIC.getID(), 
							"sendMessageToPlatform",
							message);
				}
				//clear editText
				editText.setText("");
			}
		});
	}
}
